
function [] = check3dmask(fpath,datafile,nrec)

% check3dmask(datafile)
%
% Load 3D data in "datafile", calculate a missing
% value mask and compare to pmask.bin.
% They should always be the same!!!
%
% Created  11/11/99 by adcroft@mit.edu
% Modified          by
% Maintained by adcroft@mit.edu, abiastoch@ucsd.edu

%%% Read model grid and masks.
eval(['load ' fpath 'GRID.mat']);
eval(['load ' fpath 'FMT.mat']);
Pmsk = rdslice([fpath 'pmask.bin'],[nxc nyc nzc],1,fmt,Ieee);

%%% Read data.
T = rdslice([fpath datafile],[nxc nyc nzc],nrec,fmt,Ieee);
Tmsk = ones([nxc nyc nzc]);
Tmsk(T==0) = 0;

%%% Finf mismatchs.
mismatch = find(Pmsk~=Tmsk);

%%% Stop if any mismatch.
if isempty(mismatch)
 report('check3dmask(%i th-record of "%s") passed  OK\n',nrec,datafile)
else
 report('I found %i points where %i th-record of %s mis-matched %s\n',...
   prod(size(mismatch)),nrec,[fpath datafile],[fpath 'pmask.bin']);
 error('check3dmask FAILED!!')
end
