
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Extract HYCOM fields for a given domain
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [Tm,xc,yc,zc] = exinthycomic(fpath,var,data,nrec,lon_hycom,lat_hycom,z_hycom,xc,yc,xf,yf,zc,fmt,Ieee);
warning('off')
eval(['load ' fpath 'FMT.mat']);
eval(['load ' fpath 'GRID.mat']);
msk = rdslice([fpath 'pmask.bin'],[nxc nyc nzc],1,fmt,Ieee);

TL = squeeze(data);
xl = lon_hycom;
yl = lat_hycom;
zl = z_hycom;
[nxl,nyl,nzl] = size(TL);

%% interp2guass needs a dummy mask
maskinter2guass = ones(nxc,nyc);


%%% Interpolate horizontaly.
T = zeros(nxc,nyc);
report('XY-Interpolating k = xxx');
for k = 1:nzl,
 report('\b\b\b%3i',k)
 if strcmp(var,'T') == 1 | strcmp(var,'S') == 1
     TTL = xyexpand(TL(:,:,k),100);
     TTL(isnan(TTL) == 1) = 0;
     %% smoothing with interp2gauss.m 
     %%%% (scale used is 0.25, and radius also 0.25 degrees
%      T = interp2gauss(yl',xl', squeeze(TTL),yc,xc',maskinter2guass,0.25,0.25);
     %% not using bilinear interpolation using interp2
     T = interp2(yl',xl', squeeze(TTL),yc,xc,'linear');
 elseif strcmp(var,'U') == 1
     TTL = xyexpand(TL(:,:,k),100);
     TTL(isnan(TTL) == 1) = 0;
     %% smoothing with interp2gauss.m 
     %%%% (scale used is 0.25, and radius also 0.25 degrees
%      T = interp2gauss(yl',xl', squeeze(TTL) ,yc,xf',maskinter2guass,0.25,0.25);
     %% not using bilinear interpolation using interp2
     T = interp2(yl',xl', squeeze(TTL),yc,xf,'linear');
 elseif strcmp(var,'V') == 1
     TTL = xyexpand(TL(:,:,k),100);
     TTL(isnan(TTL) == 1) = 0;
     %% smoothing with interp2gauss.m 
     %%%% (scale used is 0.25, and radius also 0.25 degrees
%      T = interp2gauss(yl',xl', squeeze(TTL),yf,xc',maskinter2guass,0.25,0.25);
     %% not using bilinear interpolation using interp2
     T = interp2(yl',xl', squeeze(TTL),yf,xc,'linear');
 end
 T(isnan(T)) = 0;
 wrslice('tmpfile.dat',T,k,fmt,Ieee);
end
report('\n')
clear TL;


%%% Interpolate verticaly.
report('Z-Interpolating j = xxxx');
T = rdslice('tmpfile.dat',[nxc nyc nzl],1,fmt,Ieee);
Tm = zeros(nxc,nyc,nzc);
for j = 1:nyc
 report('\b\b\b\b%4i',j)
 Tm(:,j,:) = interp1(zl,sq(T(:,j,:))',zc)';
end
report('\n')
wrslice('tmpfile.dat',Tm,1,fmt,Ieee);
clear T Tm;


%%% Mask and save outputs.
kdep = zeros(nxc,nyc);
report('Masking k = xxx');
for k = 1:nzc
  report('\b\b\b%3i',k)
  Tm = rdslice('tmpfile.dat',[nxc nyc],k,fmt,Ieee);
  Ti = Tm.*msk(:,:,k);
  wrslice('tmpfile.dat',Ti,k,fmt,Ieee);
end
report('\n')

Tm = rdslice('tmpfile.dat',[nxc*nyc nzc],1,fmt,Ieee);
Tm(isnan(Tm)) = 0;
delete tmpfile.dat
